#include <assert.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bignum.h"
#include "util.h"

int
bnum_mul(struct bignum *c, const struct bignum *a, const struct bignum *b)
{
	unsigned int ok, cc;
	
	assert(c != NULL && a != NULL && b != NULL);
	
	if (a->sign != b->sign)
		c->sign = 1;
	else
		c->sign = 0;

	int res_len = a->len + b->len;
	
	ok = bnum_ensure_len(c, res_len);

	if (!ok)
		return BIGNUM_NOMEM;
										//дальше идут злые циклы
	c->len = res_len;
	
	memset(c->val, 0, c->len);
	cc = 0;
	int i, j, k = 0;
	int a_val, b_val;
	
	for (i = 0; i <= res_len-1; i++) {
		
		for (j = 0; j <= i; j++) {
			
			a_val = (j <= a->top) ? a->val[j] : 0;
			b_val = (i - j <= b->top) ? b->val[i-j] : 0;
			
			cc = a_val * b_val + c->val[i];
			
			c->val[i] = cc % BIGNUM_BASE;

			cc = cc>>16;					// cc = cc/BASE analog
			
			while ( cc != 0 ) {				//sum tail with higher digits
				k++;
				cc += c->val[i+k];
				c->val[i + k] = cc % BIGNUM_BASE;
				cc = cc>>16;
			}
			k = 0;
		}
	}

	for (i = 0; i <= res_len; i++) 
		if (c->val[i] != 0)
			c->top = i;
		
	return 0;
}
